from wikitcms.wiki import Wiki, ResTuple
import mwclient.errors
from . import log
from . import conf_test_cases
import os
logger = log.get_logger(__name__)
def wiki_report(data, result):
    wiki_hostname= data.get('wiki_hostname') or 'fedoraproject.org'
    do_report=data.get("do_report") or True
    name = ''
    firmware = 'BIOS'
    imagetype = 'netinst'
    testtype = ''
    testname = ''
    testcase = ''
    bootmethod = 'x86_64 BIOS'
    section = ''
    env = ''
    arch = data.get('cpu-arch') or 'x86_64'
    if data["ts_name"] == "QA:Testcase_arm_image_deployment":
        subvariant = data.get('real-distro_variant') or 'Server'
    else:
        subvariant = data.get('beaker-distro_variant') or 'Server'
    if data.get('boot_description') == 'BIOS':
        bootmethod = 'x86_64 BIOS'
        firmware = 'BIOS'
    elif data.get('boot_description') == 'UEFI':
        bootmethod = 'x86_64 UEFI'
        firmware = 'UEFI'
    if data.get('cpu-arch') == 'aarch64':
        bootmethod = 'aarch64'
        firmware = 'aarch64'
    vm_hw = data.get('vm_hw') or 'HW'
    subvariant_or_local = data.get('subvariant_or_local') or 'Local'
    cloud_or_base = "Cloud"
    if do_report:
        testcases = []
        if 'upgrade_dnf' in data["ts_name"] or data["ts_name"] == 'QA:Testcase_Install_to_Previous_KVM':
            cid = data["real-distro"]
        else:
            cid = data["beaker-distro"]
        for key, value in conf_test_cases.TESTCASES.items():
            if key == data["ts_name"]:
                changed = {}
                for k, v in value.items():
                    v = v.replace('$FIRMWARE$', firmware)
                    v = v.replace('$RUNARCH$', arch)
                    v = v.replace('$BOOTMETHOD$', bootmethod)
                    v = v.replace('$SUBVARIANT$', subvariant)
                    v = v.replace('$IMAGETYPE$', imagetype)
                    v = v.replace('$VM_HW$', vm_hw)
                    v = v.replace('$SUBVARIANT_OR_LOCAL$', subvariant_or_local)
                    v = v.replace('$CLOUD_OR_BASE$', cloud_or_base)
                    changed[k] = v
                testcase = key
                testtype = changed["type"]
                section = changed["section"]
                env = changed["env"]
                testname = changed.get('name', '')
                if 'Testcase_upgrade_dnf_current' in key:
                    value_any = conf_test_cases.TESTCASES['QA:Testcase_upgrade_dnf_current_any']
                    changed_any = {}
                    for k, v in value_any.items():
                        v = v.replace('$FIRMWARE$', firmware)
                        v = v.replace('$RUNARCH$', arch)
                        v = v.replace('$BOOTMETHOD$', bootmethod)
                        v = v.replace('$SUBVARIANT$', subvariant)
                        v = v.replace('$IMAGETYPE$', imagetype)
                        v = v.replace('$VM_HW$', vm_hw)
                        changed_any[k] = v
                    testcase_any = 'QA:Testcase_upgrade_dnf_current_any'
                    testtype_any = changed_any["type"]
                    section_any = changed_any["section"]
                    env_any = changed_any["env"]
                    testname_any = changed_any.get('name', '')
                    testcase_any = ResTuple(
                        testtype=testtype, testcase=testcase_any, testname=testname, section=section,
                        env=env, status=result, bot=True, cid=cid)
                    testcases.append(testcase_any)
                    logger.info("reporting test %s passes to %s", testcase_any, wiki_hostname)
                if 'Testcase_upgrade_dnf_previous' in key:
                    value_any = conf_test_cases.TESTCASES['QA:Testcase_upgrade_dnf_previous_any']
                    changed_any = {}
                    for k, v in value_any.items():
                        v = v.replace('$FIRMWARE$', firmware)
                        v = v.replace('$RUNARCH$', arch)
                        v = v.replace('$BOOTMETHOD$', bootmethod)
                        v = v.replace('$SUBVARIANT$', subvariant)
                        v = v.replace('$IMAGETYPE$', imagetype)
                        v = v.replace('$VM_HW$', vm_hw)
                        changed_any[k] = v
                    testcase_any = 'QA:Testcase_upgrade_dnf_previous_any'
                    testtype_any = changed_any["type"]
                    section_any = changed_any["section"]
                    env_any = changed_any["env"]
                    testname_any = changed_any.get('name', '')
                    testcase_any = ResTuple(
                        testtype=testtype, testcase=testcase_any, testname=testname, section=section,
                        env=env, status=result, bot=True, cid=cid)
                    testcases.append(testcase_any)
                    print("testcase111 %s"%testcase)
                    logger.info("reporting test %s passes to %s", testcase_any, wiki_hostname)
                break
                # we only pass one testcase each time,so we break here to save time

        testcase = ResTuple(
            testtype=testtype, testcase=testcase, testname=testname, section=section,
            env=env, status=result, bot=True, cid=cid)
        testcases.append(testcase)
        logger.info("reporting test %s passes to %s", testcase, wiki_hostname)

    #todo put this to config file
        wiki = Wiki(wiki_hostname, max_retries=40)
        if not wiki.logged_in:
            # This seems to occasionally throw bogus WrongPass errors
            try:
                wiki.login()
            except mwclient.errors.LoginError:
                wiki.login()
            if not wiki.logged_in:
                logger.error("could not log in to wiki")
                raise LoginError

        # Submit the results
        (insuffs, dupes) = wiki.report_validation_results(testcases)
        for dupe in dupes:
            tmpl = "already reported result for test %s, env %s! Will not report dupe."
            logger.info(tmpl, dupe.testcase, dupe.env)
            logger.debug("full ResTuple: %s", dupe)
        for insuff in insuffs:
            tmpl = "insufficient data for test %s, env %s! Will not report."
            logger.info(tmpl, insuff.testcase, insuff.env)
            logger.debug("full ResTuple: %s", insuff)

    else:
        logger.warning("no reporting is done")

def run_playbook(playbook, hosts=None, user=None, private_key=None, tags=None,
                 verbose=False, ignore_fail=False, extra_vars_file=None,
                 debug=False, **extra_vars):
    resource_dir = RESOURCE_PATH
    if not playbook.endswith(('.yaml', '.yml')):
        playbook_path = os.path.join(
            resource_dir, 'playbooks', playbook + '.yaml')
    else:
        playbook_path = os.path.join(
            resource_dir, 'playbooks', playbook)

    verbosity = 0
    ssh_args = None
    inventory_path = ''
    if user is None:
        user = 'root'
    try:
        inventory_path, host_list = format_inventory(hosts, user)
        if any('pok' in s for s in host_list):
            ssh_args = '-F %s' % os.path.join(
                CONFIG_PATH, 'ibm_pok_ssh_config')

        if private_key:
            private_key = os.path.join(KEY_PATH, private_key)
        if verbose:
            verbosity = 3
        if extra_vars_file:
            with open(extra_vars_file) as extra_vars_f:
                extra_vars.update(yaml.load(extra_vars_f))
        new_ans = ansible.Ansible(host_list=inventory_path,

                                  private_key=private_key,
                                  extra_vars=extra_vars,
                                  tags=tags,
                                  ssh_args=ssh_args,
                                  verbosity=verbosity)
        rc, result = new_ans.run_playbook(playbook_path)
        fail_msgs = ["Failed to retrive ansible result with:"]
        if rc == 0:
            return 'pass'
        else:
            return 'fail'
    finally:
        try:
            os.remove(inventory_path)
        except (OSError, IOError):
            pass


