import os
import sys
import glob

from setuptools import setup, Command

def get_data_files():
    def add_files(level=[]):
        installed_location = ['usr', 'share', 'fedora-release-autotest']
        installed_location += level
        level_str = '/'.join(level)
        if level_str:
            level_str += '/'
        file_glob = '%s*' % level_str
        files_found = [path for path in glob.glob(file_glob) if
                       os.path.isfile(path)]
        return [(os.path.join(*(['/'] + installed_location)), files_found)]
    data_files = add_files(["openstack-playbook"])

    return data_files

setup(
    name="fedora-release-autotest",
    version="1.0",
    description="Listens to ci messages for compose complete and"
    "trigger beaker jobs",
    author="Lili Nie",
    author_email="lnie@fedoraproject.org",
    license="GPLv2+",
    url="https://pagure.io/fedora-release-autotest",
    packages=["fedora_release_autotest"],
    data_files=get_data_files(),
    include_package_data=True,
    install_requires=open('install.requires').read().splitlines(),
)
